using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ScaffoldingExample.Helpers
{
    /// <summary>
    /// Определяет методы, необходимые для задания порядка 
    /// </summary>
    public interface IOrderHelper<T> where T : new() 
    {
        /// <summary>
        /// Определение минимального порядка для множества
        /// </summary>
        int MinOrder(IEnumerable<T> data);

        /// <summary>
        /// Определение максимального порядка для множества
        /// </summary>
        int MaxOrder(IEnumerable<T> data);

        /// <summary>
        /// Чтение порядка
        /// </summary>
        int GetOrder();

        /// <summary>
        /// Установка порядка и сохранение записи
        /// </summary>
        void SetOrder(int newOrder);
    }
}
